#include <tcl.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/* declare the c function(s) that will implement TCL commands */
void  SaveInterp(Tcl_Interp *interp);
void  Macro_TclWrappers(Tcl_Interp *interp); 
void  PGPLOT_TclWrappers(Tcl_Interp *interp);


#if defined(__WIN32__) /* header for VC++ and UNIX not Borland */
#   define WIN32_LEAN_AND_MEAN
#   include <windows.h>
#   undef WIN32_LEAN_AND_MEAN
#   if defined(_MSC_VER)
#	define EXPORT(a,b) __declspec(dllexport) a b
#	define DllEntryPoint DllMain
#   endif
BOOL APIENTRY
DllEntryPoint(HINSTANCE hInst, DWORD reason, LPVOID reserved)
{
    return TRUE;
}
#else
#   define EXPORT(a,b) a b
#endif

EXPORT(int, Pgtk_Init)(Tcl_Interp *interp) 
{

  /* Create ptcl commands */
 
  Macro_TclWrappers( interp ); 
  PGPLOT_TclWrappers( interp ); 

 /*  initialize  package */
  SaveInterp(interp);  /* save the interpreter pointer for the driver */

  return Tcl_PkgProvide(interp, "pgtk", "1.0");
}
